#!/usr/bin/perl -w
use strict;
use warnings;
use Net::LDAP;
my %ldap_connect=(
HOST=>"192.168.0.4",
PORT=>"389",

# Timeout search
TIMEOUT=>"120",

#  
BASE_DN=>"ou=firma-market,DC=firma-market",

#     LDAP
BIND_DN=>"CN=unix_ldap,OU=Special Users,OU=Users,OU=FIRMA-MARKET,DC=FIRMA-MARKET",

#  
BIND_PASS=>"qwas`1234",

#  LDAP
VERSION=>"3"
);
sub get_mail_lists
{
    my $address = shift;
    my ($user_mail, $dn, $mesg, $entry, $mail_lists);
    my (@array_of_ldap_search, @entries);
    $mail_lists="";
    #    (DC)
    my $ldap = Net::LDAP->new($ldap_connect{'HOST'}, version=>$ldap_connect{'VERSION'}, \
port=>$ldap_connect{'PORT'}, timeout=>$ldap_connect{'TIMEOUT'}) or die  exit 0;

    #   
    $mesg=$ldap->bind($ldap_connect{'BIND_DN'}, password => $ldap_connect{'BIND_PASS'}) or die exit 0;

    #  e-mail  
    $mesg = $ldap->search(

        base => $ldap_connect{'BASE_DN'},
        scope => 'sub',
        filter => "(&(objectClass=top)(objectClass=group)(mail=$address))",
        attrs => ['member']
        );

  #    dn  
        foreach $entry ($mesg->entries) {
                @array_of_ldap_search = $entry->get_value("member");
        }

  #      dn   
        foreach $dn (@array_of_ldap_search) {
                $mesg = $ldap->search\
        (filter=>"(&(!(userAccountControl:1.2.840.113556.1.4.803:=2))(objectClass=user)\
(objectClass=person)(distinguishedName=$dn))",
        base=>$ldap_connect{'BASE_DN'},
        scope =>'sub',
        attrs=>['mail']
        );

    #     e-mail   

                @entries = $mesg->entries;
                foreach $entry (@entries) {
            $user_mail = $entry->get_value("mail");

#    ,     .  
#   
   #$mail_lists = $mail_lists.",".$user_mail;
            $mail_lists = $mail_lists."\n".$user_mail;
                }
        }
   #$mail_lists = substr ($mail_lists,1);
        $ldap->unbind;
        return $mail_lists;
}

#    
#print get_mail_lists('dg_buh@firma-market.ru'),"\n";